<!doctype html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <title>FlywayDB and jOOQ</title>
        <meta name="description" content="Presentation on FlywayDB and jOOQ">
        <meta name="author" content="David McFarland">
        <meta name="apple-mobile-web-app-capable" content="yes" />
        <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
        <link rel="stylesheet" href="css/reveal.min.css">
        <link rel="stylesheet" href="css/theme/moon.css" id="theme">
        <link rel="stylesheet" href="lib/css/zenburn.css">
        <link rel="stylesheet" href="css/slides.css">
    </head>
    <body>
        <div class="reveal">
            <div class="slides">
                
                <section>
                    <img style="border: none; background: none;box-shadow:none;width: 60%;" src="images/instil-logo.png">
                    <h3>FlywayDB and jOOQ workshop</h3>
                    <p>
                    <small>Created by David McFarland using Reveal.js.</small>
                    </p>
                    <p>Please feel free to interrupt and ask questions...</p>
                </section>
                <section>
                    <h3>Initial Setup</h3>
                    <ol>
                        <li>Please download the archive from http://goo.gl/vSFeLb</li>
                        <p>or git clone git@gitlab.com:david.mcfarland/flyway-jooq-workshop.git.</p>
                        <li>Inside the exercises folder run:</li>
                        <ul>
                            <li>[Linux/Mac] ./gradlew tasks</li>
                            <li>[Windows] gradlew.bat tasks</li>
                        </ul>
                        <li>Signup for free Tiny turtle postgres instance at http://www.elephantsql.com/</li>
                    </ol>
                </section>
                <section>
                    <h3>Who is here?</h3>
                    <p class="fragment fade-in">Developers please raise hands.</p>
                    <p class="fragment fade-in">Database adminstrators please raise hands.</p>
                    <p class="fragment fade-in">Others please raise hands.</p>
                    <p class="fragment fade-in">Who would like to eat during halfway break?</p>
                </section>
                <section>
                    <h3>What we are going to cover</h3>
                    <h2>Flyway</h2>
                    <img style="border: none; background: none;box-shadow:none;" src="images/flyway-logo.png">
                    <p>A tool for managing database migrations using SQL on the JVM.</p>
                </section>
                <section>
                    <h3>What we are going to cover</h3>
                    <h2>jOOQ</h2>
                    <img style="border: none; background: none;box-shadow:none;" src="images/jooq-logo.png">
                    <p>A tool for generating a DSL which allows interaction with the database using type safe SQL.</p>
                </section>
                <section>
                    <h2>A quick history of database migrations</h2>
                </section>
                <section>
                    <h3>Shell scripts</h3>
                    <p>It's not hard to create a simple database migration script...</p>
 <pre>
 <code data-trim>
#! /bin/sh
for file in db/migrations/*; do
    psql -U username -d database -a -f  "$file"
done
</code>
</pre>
                </section>
                <section>
                    <h3>The complexities</h3>
                    <p class="fragment fade-in">It is good for building a schema from scratch,</p>
                    <p class="fragment fade-in">but it is not so good for migrating a schema from n to the latest version</p>
                    <p class="fragment fade-in">A more complete script needs to be able to:</p>
                    <ul class="fragment fade-in">
                        <li>Rollback in case of failing script</li>
                        <li>Handle metadata in the database to identify current schema version</li>
                        <li>Identify what scripts need run to get schema to the latest version</li>
                    </ul>
                </section>
                <section>
                    <h3>Liquidbase</h3>
 <pre>
 <code data-trim>
<databaseChangeLog
  xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog
         http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.1.xsd">
    <changeSet id="1" author="bob">
        <createTable tableName="department">
            <column name="id" type="int">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="active" type="boolean" defaultValueBoolean="true"/>
        </createTable>
    </changeSet>
</databaseChangeLog>
</code>
</pre>
                </section>
                <section>
                    <h3>Liquidbase</h3>
                    <ul>
                        <li>rollbacks in case of failing script;</li>
                        <li>handles metadata in the database to identify current schema version;</li>
                        <li>identifies what scripts need run to get schema to the latest version;</li>
                        <li>is able to generate migration scripts from Hibernate config using <a href="https://github.com/liquibase/liquibase-hibernate/wiki">Extensions</a>;</li>
                        <li>is powerful but is quite complex and abstracts you from SQL as the underlaying DDL language;</li>
                    </ul>
                </section>
                <section>
                    <h3>Flyway</h3>
                    <ul>
                        <li>Flyway manages a metadata table called schema_version in each DB instance.</li>
                        <li>On startup the application should call the migrate method.</li>
                        <li>Migration will occur as part of transaction.</li>
                        <li>Migration failures will rollback and the applciation will fail to start.</li>
                    </ul>
                </section>
                <section>
                    <h3>Flyway Commands</h3>
                    <table style="padding-left: 110px" class="table table-bordered table-hover center">
                        <thead>
                            <tr>
                                <th>Name</th>
                                <th>Description</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td><strong>migrate</strong></td>
                                <td>Migrates the database</td>
                            </tr>
                            <tr>
                                <td><strong>clean</strong></td>
                                <td>Drops all objects in the configured schemas</td>
                            </tr>
                            <tr>
                                <td><strong>info</strong></td>
                                <td>Prints the details and status information about all the migrations</td>
                            </tr>
                            <tr>
                                <td><strong>validate</strong></td>
                                <td>Validates the applied migrations against the ones available on the classpath</td>
                            </tr>
                            <tr>
                                <td><strong>init</strong></td>
                                <td>Creates and initializes the metadata table (existing database)</td>
                            </tr>
                            <tr>
                                <td><strong>repair</strong></td>
                                <td>Repairs the metadata table</td>
                            </tr>
                        </tbody>
                    </table>
                </section>
                <section>
                    <h2>Intro to Gradle</h2>
    <pre><code data-trim>
./gradlew tasks
:tasks
------------------------------------------------------------
All tasks runnable from project :exercise1
------------------------------------------------------------
      
Build tasks
-----------
assemble - Assembles the outputs of this project.
build - Assembles and tests this project.
buildDependents - Assembles and tests this project and all projects that depend on it.
buildNeeded - Assembles and tests this project and all projects it depends on.
classes - Assembles classes 'main'.
clean - Deletes the build directory.
jar - Assembles a jar archive containing the main classes.
testClasses - Assembles classes 'test'.
......
</code></pre>
                </section>
                
                <section>
                    <h2>Intro to Gradle Build</h2>
<pre><code data-trim>
apply plugin: 'java'
        
dependencies {
    compile fileTree(dir: 'lib', include: ['*.jar'])
    compile 'org.flywaydb:flyway-core:3.0'    
    compile 'org.postgresql:postgresql:9.3-1101-jdbc41'
}
          
/**************
 * Database connection properties
 **************/
project.ext.dbUrl = "jdbc:postgresql://horton.elephantsql.com:5432/pspeirsg"
project.ext.dbUser = 'pspeirsg'
project.ext.dbPassword = 'FdqlWdvdiWV1X7jH0aLZd86ioNyKd1zP'
          
/**************
 * Tasks
 **************/
task runApp(type: JavaExec, description: "Start exercise application") {
    standardInput = System.in
    classpath project.sourceSets.main.runtimeClasspath
    main = "co.instil.flyway.FlywayApplication"
    args = [project.ext.dbUrl, project.ext.dbUser, project.ext.dbPassword]
}
       
task databaseCLI(type: JavaExec, description: "A CLI for interacting with the database.") {
    standardInput = System.in
    classpath project.sourceSets.main.runtimeClasspath
    main = "com.xigole.util.sql.Jisql"
    args = ["-user", project.ext.dbUser, "-password", project.ext.dbPassword, "-driver", "postgresql", "-cstring", project.ext.dbUrl, "-c", ";"]
}
</code></pre>
                </section>
                <section>
                    <h3>Exercise 1</h3>
                    
                    <p>Goto exercises/exercise1</p>
                    
                        <code><pre>
├── README.md
├── build.gradle
├── .gradle
├── gradlew
├── gradlew.bat
└── src
    └── main
        ├── java
        │   └── co
        │       └── instil
        │           └── flyway
        │               └── FlywayApplication.java
        └── resources
            └── db
                └── migration
                    └── V1__CREATE_STUDENT_TABLE.sql
</code></pre>
                    
                </section>
                <section>
                    <h3>Exercise 1 (Cont.)</h3>
                    <ol>
                        <li>Run ./gradlew tasks</li>
                        <li>Run ./gradlew runApp</li>
                        <li>Add the definition of the following table to V1__CREATE_STUDENT_TABLE.sql</li>
                        <img style="border: none; background: none;box-shadow:none;" src="images/studentTable.png">
                        <li>Add migration step to FlywayApplication.java</li>
                        <li>Run ./gradlew runApp</li>
                        <li>Output should show that the state for version 1 has changed from pending to success.</li>
                    </ol>
                </section>
                <section>
                    <h3>Exercise 1 (Cont.)</h3>
                    <ol>
                        <li>Add the definition of the following table to V2__CREATE_SUBJECT_TABLE.sql</li>
                        <img style="border: none; background: none;box-shadow:none;" src="images/subjectTable.png">
                        <li>Make the script invalid and run ./gradlew runApp</li>
                        <li>Correct the script and rerun ./gradlew runApp</li>
                    </ol>
                </section>
                <section>
                    <h3>The Android way</h3>
<pre>
<code data-trim>
public class EventsData extends SQLiteOpenHelper {
    private static final String DATABASE_NAME = "events.db"; 
    private static final int DATABASE_VERSION = 1;
   
    public EventsData(Context ctx) {
        super(ctx, DATABASE_NAME, null, DATABASE_VERSION);
    }
    
    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL("CREATE TABLE " + TABLE_NAME + " (" + _ID + " INTEGER PRIMARY KEY AUTOINCREMENT, " 
        + TIME + " INTEGER," + TITLE + " TEXT NOT NULL);");
    }
    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        db.execSQL("DROP TABLE IF EXISTS " + TABLE_NAME); onCreate(db);
    }
}
</code>
</pre>
                </section>
                <section>
                    <h3>Flyway supports</h3>
                    <ul>
                        <li>Oracle</li>
                        <li>SQL Server</li>
                        <li>SQL Azure</li>
                        <li>DB2</li>
                        <li>MySQL</li>
                        <li>MariaDB</li>
                        <li>Google Cloud SQL</li>
                        <li>PostgreSQL</li>
                        <li>H2</li>
                        <li>Hsql</li>
                        <li>Derby</li>
                        <li>SQLite including on Android using SQLDroid driver...</li>
                        <li>Muliple Schemas</li>
                    </ul>
                </section>
                <section>
                    <h3>Interacting with the database from Java (Cont.)</h3>
<pre><code data-trim>
// String concatenation - very secure
String insertTableSQL = "INSERT INTO DBUSER"
                + "(USER_ID, USERNAME, CREATED_BY, CREATED_DATE) " + "VALUES"
                + "(1,'Marco','system', " + "to_date('"
                + getCurrentTimeStamp() + "', 'yyyy/mm/dd'))";
// Slightly better example using prepared statements
String updateTableSQL = "UPDATE DBUSER SET USERNAME = ? WHERE USER_ID = ?";
PreparedStatement preparedStatement = dbConnection.prepareStatement(updateTableSQL);
</code></pre>
                </section>
                <section>
                    <h3>Interacting with the database from Java (Cont.)</h3>
<pre><code data-trim>
@Entity
@Table(name="EMPLOYEE")
public class Employee {
 
    @Id @GeneratedValue @Column(name="employee_id")
    private Long employeeId;
     
    @Column(name="name")
    private String name;
     
    @ManyToOne @JoinColumn(name="department_id")
    private Department department;
    @ManyToMany(cascade = {CascadeType.ALL}) @JoinTable(name="EMPLOYEE_MEETING", joinColumns={@JoinColumn(name="EMPLOYEE_ID")}, 
                inverseJoinColumns={@JoinColumn(name="MEETING_ID")})
    private Set&ltMeeting&gt meetings = new HashSet<>();
</code></pre>
                </section>
                <section>
                    <h3>Using jOOQ</h3>
                    <ol>
                        <li>Point the jOOQ codegen tool at a database.</li>
                        <li>This will generate a SQL DSL representation of the schema.</li>
                        <li>It can also be configured to generate POJO, DAO object, etc.</li>
                        <li>Using this generated code you interact with the database.</li>
<pre>
<code data-trim>
// Prints table of books published in 2011.
create.selectFrom(BOOK)
      .where(BOOK.PUBLISHED_IN.eq(2011)) // Type safe - you can't use a string for 2011
      .orderBy(BOOK.TITLE)
      .fetch().format();
// Inserting using SQL DSL.
create.insertInto(STUDENT, STUDENT.FIRST_NAME, STUDENT.LAST_NAME, STUDENT.DATE_OF_BIRTH)
      .values(random(firstName), random(lastName), randomDob())
      .execute(); // Important - won't execute until run, its possible to batch commands.
// Selecting into POJO objects.
List<Book> books = create.select().from(BOOK).fetchInto(Book.class);
// Selecting book using a generated DAO object.
Book book = bookDao.findById(5);
</code></pre>
                    </ol>
                    
                </section>
                
                <section>
                    <h2>jOOQ Gradle task</h2>
    <pre><code data-trim>
jooq {
    jdbc {
        url "${project.ext.dbUrl}"
        driver "org.postgresql.Driver"
        user "${project.ext.dbUser}"
        password "${project.ext.dbPassword}"
    }
    generator {
        database {
            name  "org.jooq.util.postgres.PostgresDatabase"
            inputSchema "workshop"
            includes ".*"
        }
        generate {
            daos true
        }
        target {
            packageName "org.jooq.instil"
            directory "src/generated/java"
        }
    }
}
</code></pre>
                </section>
                <section>
                    <h2>A little more gradle</h2>
    <pre><code data-trim>
apply plugin: 'eclipse'
apply plugin: 'idea'
.....
:tasks
IDE tasks
---------
cleanEclipse - Cleans all Eclipse files.
cleanIdea - Cleans IDEA project files (IML, IPR)
eclipse - Generates all Eclipse files.
idea - Generates IDEA project files (IML, IPR, IWS)
</code></pre>
                </section>
                <section>
                    <h2>Exercise 2</h2>
                    <ol>
                        <li>Go to Exercise 2 folder</li>
                        <li>Run ./gradlew flywayClean runApp</li>
                        <li>Implement the following functions in SchoolService.java</li>
                        <ul>
                            <li>populateWithSubjects</li>
                            <li>populateWithResults</li>
                            <li>printStudentsMarks</li>
                        </ul>
                        <ol>
                        </section>
                        <section>
                            <h2>Using more sophisticated database functions</h2>
                        <pre><code data-trim>
// Window Functions
SELECT depname, empno, salary, avg(salary) OVER (PARTITION BY depname) FROM empsalary;
    
// Procedure wrapping
CREATE OR REPLACE PROCEDURE author_exists (author_name VARCHAR2, result OUT NUMBER, id OUT NUMBER);
    
// Generated routine classes
AuthorExists procedure = new AuthorExists();
procedure.setAuthorName("Paulo");
procedure.execute(configuration);
assertEquals(new BigDecimal("1"), procedure.getResult());
assertEquals(new BigDecimal("2"), procedure.getId();
</code></pre>
                        </section>
                        
                        <section>
                            <h2>Exercise 3</h2>
                            <ol>
                                <li>Go to Exercise 3 folder</li>
                                <li>Run ./gradlew runApp</li>
                                <li>Implement the following functions in SchoolService.java</li>
                                <ul>
                                    <li>printStudentRank</li>
                                </ul>
                            </ol>
                        </section>
                        <section>
                            <h2>The END.</h2>
                            <p>Thanks for attending.</p>
                            
                        </section>
                    </div>
                </div>
                <script src="lib/js/head.min.js"></script>
                <script src="js/reveal.min.js"></script>
                <script>
                Reveal.initialize({
                controls: false,
                progress: true,
                history: true,
                center: true,
                width: 1680,
                height: 1400,
                margin: -0.05,
                minScale: 0.9,
                maxScale: 1.0,
                theme: Reveal.getQueryHash().theme,
                transition: Reveal.getQueryHash().transition || 'default',
                dependencies: [
                { src: 'lib/js/classList.js', condition: function() { return !document.body.classList; } },
                { src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
                { src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
                { src: 'plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
                { src: 'plugin/zoom-js/zoom.js', async: true, condition: function() { return !!document.body.classList; } },
                { src: 'plugin/notes/notes.js', async: true, condition: function() { return !!document.body.classList; } }
                ]
                });
                </script>
            </body>
        </html>